/* 
Modified linker script org: mspgcc/msp430/lib/ldscripts/msp430x1612.x 
For ScatterWeb Bootloader
*/

OUTPUT_FORMAT("elf32-msp430","elf32-msp430","elf32-msp430")
OUTPUT_ARCH(msp:16)
MEMORY 
{
	infomem(r)		: ORIGIN = 0x1000,	LENGTH = 256
	infomemnobits(r): ORIGIN = 0x1000,  LENGTH = 256
	data(rwx)  		: ORIGIN = 0x1100, 	LENGTH = 0x1400
	rom(rx)			: ORIGIN = 0x2500,	LENGTH = 55K
    INT00(rx)       : ORIGIN = 0xFFE0,	LENGTH = 0x0002
	INT01(rx)       : ORIGIN = 0xFFE2,	LENGTH = 0x0002
	INT02(rx)       : ORIGIN = 0xFFE4,	LENGTH = 0x0002
	INT03(rx)       : ORIGIN = 0xFFE6,	LENGTH = 0x0002
	INT04(rx)       : ORIGIN = 0xFFE8,	LENGTH = 0x0002
	INT05(rx)       : ORIGIN = 0xFFEA,	LENGTH = 0x0002
	INT06(rx)       : ORIGIN = 0xFFEC,	LENGTH = 0x0002
	INT07(rx)       : ORIGIN = 0xFFEE,	LENGTH = 0x0002
	INT08(rx)       : ORIGIN = 0xFFF0,	LENGTH = 0x0002
	INT09(rx)       : ORIGIN = 0xFFF2,	LENGTH = 0x0002
	INT10(rx)       : ORIGIN = 0xFFF4,	LENGTH = 0x0002
	INT11(rx)       : ORIGIN = 0xFFF6,	LENGTH = 0x0002
	INT12(rx)       : ORIGIN = 0xFFF8,	LENGTH = 0x0002
	INT13(rx)       : ORIGIN = 0xFFFA,	LENGTH = 0x0002
	INT14(rx)       : ORIGIN = 0xFFFC,	LENGTH = 0x0002
    RESET           : ORIGIN = 0xFFFE,	LENGTH = 0x0002
}

SECTIONS
{

  /*****************************************************************************
   ***                                                                       ***
   *** Text section (goes all into flash memory)                             ***
   ***                                                                       ***
   *****************************************************************************/

	.text : {
		PROVIDE( __bld_start = . ); 

		*(.app_header)
		. = ALIGN(2);
		*(.text)
		. = ALIGN(2);
		*(.text.*)

		. = ALIGN(0x200);
		PROVIDE( __bld_end = . );		
	} > rom
	_etext = .;
  
	PROVIDE( __bld_header = __bld_start );
	PROVIDE( __bld_size = __bld_end - __bld_start );
  
/*
    .int00   : {} > INT00
    .int01   : {} > INT01
    .int02   : {} > INT02
    .int03   : {} > INT03
    .int04   : {} > INT04
    .int05   : {} > INT05
    .int06   : {} > INT06
    .int07   : {} > INT07
    .int08   : {} > INT08
    .int09   : {} > INT09
    .int10   : {} > INT10
    .int11   : {} > INT11
    .int12   : {} > INT12
    .int13   : {} > INT13
    .int14   : {} > INT14
*/
    .reset   : {start = .;} > RESET

  /*****************************************************************************
   ***                                                                       ***
   *** Data + bss section (goes all into RAM memory)                         ***
   ***                                                                       ***
   *****************************************************************************/  

	/*
	.bss : {} > data  
	.data : {} > data
	*/
  /*****************************************************************************
   ***                                                                       ***
   *** Other                                                                 ***
   ***                                                                       ***
   *****************************************************************************/  

  /* Stabs for profiling information*/
  .profiler 0 : { *(.profiler) }
  /* Stabs debugging sections.  */
  .stab 0 : { *(.stab) }
  .stabstr 0 : { *(.stabstr) }
  .stab.excl 0 : { *(.stab.excl) }
  .stab.exclstr 0 : { *(.stab.exclstr) }
  .stab.index 0 : { *(.stab.index) }
  .stab.indexstr 0 : { *(.stab.indexstr) }
  .comment 0 : { *(.comment) }
  /* DWARF debug sections.
     Symbols in the DWARF debugging sections are relative to the beginning
     of the section so we begin them at 0.  */
  /* DWARF 1 */
  .debug          0 : { *(.debug) }
  .line           0 : { *(.line) }
  /* GNU DWARF 1 extensions */
  .debug_srcinfo  0 : { *(.debug_srcinfo) }
  .debug_sfnames  0 : { *(.debug_sfnames) }
  /* DWARF 1.1 and DWARF 2 */
  .debug_aranges  0 : { *(.debug_aranges) }
  .debug_pubnames 0 : { *(.debug_pubnames) }
  /* DWARF 2 */
  .debug_info     0 : { *(.debug_info) *(.gnu.linkonce.wi.*) }
  .debug_abbrev   0 : { *(.debug_abbrev) }
  .debug_line     0 : { *(.debug_line) }
  .debug_frame    0 : { *(.debug_frame) }
  .debug_str      0 : { *(.debug_str) }
  .debug_loc      0 : { *(.debug_loc) }
  .debug_macinfo  0 : { *(.debug_macinfo) }
  
  PROVIDE (__stack = 0x2500) ;
  PROVIDE (__data_start_rom = _etext) ;
  PROVIDE (__data_end_rom   = _etext + SIZEOF (.data)) ;
  PROVIDE (__noinit_start_rom = _etext + SIZEOF (.data)) ;
  PROVIDE (__noinit_end_rom = _etext + SIZEOF (.data) + SIZEOF (.noinit)) ;
  PROVIDE (__image_end = _etext + SIZEOF (.data) + SIZEOF (.noinit)) ; /* ADDED */
  PROVIDE (__subdevice_has_heap = 0) ;
}
